plotKmerDist <- function(dat, baseDat, saveDatFn, dontPlot){
    if (!is.na(saveDatFn)){
        save(dat, file=saveDatFn)
    }
    if (dontPlot){ return() }
    mainP <- ggplot(dat) +
        ##geom_boxplot(aes(x=Kmer, y=Signal, color=Base)) +
        ##scale_color_manual(
        ##    values=c('#00CC00', '#0000CC', '#FFB300', '#CC0000')) +
        geom_violin(aes(x=Kmer, y=Signal, fill=Base), size=0) +
        scale_fill_manual(
            values=c('#00CC00', '#0000CC', '#FFB300', '#CC0000')) +
        theme_bw() +
        theme(
            axis.text.x=element_text(angle=60, hjust=1, size=8),
            legend.position='bottom',
            panel.grid.major.x=element_line(size=0.01))
    if (is.na(baseDat)){
        print(mainP)
    } else {
        ##mainL <- get_legend(mainP)
        ##mainP <- mainP + theme(legend.position='none')
        baseP <- ggplot(baseDat) +
            geom_tile(aes(x=Kmer, y=Position, fill=Base)) +
            scale_fill_manual(
                values=c('A'='#00CC00', 'C'='#0000CC',
                         'G'='#FFB300', 'T'='#CC0000')) +
            theme_bw() +
            theme(
                axis.text.x=element_text(angle=60, hjust=1, size=8),
                legend.position='none')
        mainP <- mainP + theme(axis.text.x=element_blank(),
                               axis.title.x=element_blank())
        if (nchar(as.character(dat$Kmer[1])) > 3){
            mainP <- mainP + theme(axis.text.x=element_blank())
            baseP <- baseP + theme(axis.text.x=element_blank())
        }
        pdf('/dev/null')
        mainP <- ggplot_gtable(ggplot_build(mainP))
        baseP <- ggplot_gtable(ggplot_build(baseP))
        maxWidth = grid::unit.pmax(mainP$widths[2:3], baseP$widths[2:3])
        mainP$widths[2:3] <- maxWidth
        baseP$widths[2:3] <- maxWidth
        foo <- dev.off()
        grid.arrange(mainP, baseP, ncol=1, heights=c(5,1))
        ##plot_grid(plot_grid(mainP, baseP, ncol=1,
        ##                      rel_heights=c(5,1), align='v'),
        ##            mainL, ncol=1, rel_heights=c(10,1)))
    }}

plotKmerDistWReadPath <- function(dat, baseDat, saveDatFn, dontPlot){
    if (!is.na(saveDatFn)){
        save(dat, file=saveDatFn)
    }
    if (dontPlot){ return() }
    maxVal <- max(as.numeric(dat$Kmer))
    mainP <- ggplot(dat) +
        #geom_boxplot(aes(x=Kmer, y=Signal, color=Base)) +
        #scale_color_manual(
        #    values=c('#00CC00', '#0000CC', '#FFB300', '#CC0000')) +
        geom_violin(aes(x=Kmer, y=Signal, fill=Base), size=0) +
        scale_fill_manual(
            values=c('#00CC00', '#0000CC', '#FFB300', '#CC0000')) +
        theme_bw() +
        theme(axis.text.x=element_text(angle=60, hjust=1, size=8),
              legend.position='bottom',
              panel.grid.major.x=element_line(size=0.01))
    readP <- ggplot(dat) +
        geom_path(aes(x=Kmer, y=Signal, group=Read),
                  alpha=0.05, size=0.5) +
        theme_bw() +
        theme(axis.text.x=element_text(angle=60, hjust=1, size=8),
              panel.grid.major.x=element_line(size=0.01)) +
        scale_color_manual(
            values=c('#00CC00', '#0000CC', '#FFB300', '#CC0000'))
    if (is.na(baseDat)){
        print(mainP)
        print(readP)
    } else {
        #mainL <- get_legend(mainP)
        #mainP <- mainP + theme(legend.position='none')
        baseP <- ggplot(baseDat) +
            geom_tile(aes(x=Kmer, y=Position, fill=Base)) +
            scale_fill_manual(
                values=c('A'='#00CC00', 'C'='#0000CC',
                         'G'='#FFB300', 'T'='#CC0000')) + theme_bw() +
           theme(axis.text.x=element_text(angle=60, hjust=1, size=8),
                 legend.position='none')
        mainP <- mainP + theme(axis.text.x=element_blank(),
                               axis.title.x=element_blank())
        readP <- readP + theme(axis.text.x=element_blank(),
                               axis.title.x=element_blank())
        if (nchar(as.character(dat$Kmer[1])) > 3){
            mainP <- mainP + theme(axis.text.x=element_blank())
            readP <- readP + theme(axis.text.x=element_blank())
            baseP <- baseP + theme(axis.text.x=element_blank())
        }
        pdf('/dev/null')
        mainP <- ggplot_gtable(ggplot_build(mainP))
        readP <- ggplot_gtable(ggplot_build(readP))
        baseP <- ggplot_gtable(ggplot_build(baseP))
        maxWidth = grid::unit.pmax(mainP$widths[2:3], readP$widths[2:3],
                                   baseP$widths[2:3])
        mainP$widths[2:3] <- maxWidth
        readP$widths[2:3] <- maxWidth
        baseP$widths[2:3] <- maxWidth
        foo <- dev.off()
        grid.arrange(mainP, baseP, ncol=1, heights=c(5,1))
        grid.arrange(readP, baseP, ncol=1, heights=c(5,1))
        ##print(plot_grid(plot_grid(mainP, baseP, ncol=1,
        ##                          rel_heights=c(5,1), align='v'),
        ##                mainL, ncol=1, rel_heights=c(10,1)))
        ##print(plot_grid(plot_grid(readP, baseP, ncol=1,
        ##                          rel_heights=c(5,1), align='v'),
        ##                mainL, ncol=1, rel_heights=c(10,1)))
}}

library(ggplot2)
library(stringr)
library(ggridges)


## density basename and alternative base
densBase <- 'debug_est_alt'
altBase <- 'C'


## parse density data
densDat <- read.table(paste0(densBase, '.alternate_density.txt'), header=TRUE)
standardDensDat <- read.table(paste0(densBase, '.control_density.txt'), header=TRUE)
densDat$Sample <- "Alternative"
standardDensDat$Sample <- "Standard"

allDensDat <- rbind.data.frame(densDat, standardDensDat)
sAllDat <- split(allDensDat, allDensDat$Kmer)
sDiffs <- sort(unlist(lapply(sAllDat, function(x)
    weighted.mean(x[x$Sample == 'Alternative','Signal'], x[x$Sample == 'Alternative','Density']) -
    weighted.mean(x[x$Sample == 'Standard','Signal'], x[x$Sample == 'Standard','Density']))))


## plot k-mers with the largest shifts in average signal level
upDat <- do.call(rbind.data.frame, lapply(names(head(sDiffs, 20)), function(kmer) sAllDat[[kmer]]))
dnDat <- do.call(rbind.data.frame, lapply(names(tail(sDiffs, 20)), function(kmer) sAllDat[[kmer]]))

pdf(paste0(densBase, '.density.pdf'), width=10)
ggplot(upDat, aes(x=Signal, y=Kmer, height=Density, fill=Sample)) +
    geom_ridgeline(alpha=0.4, size=0, color='white') +
    scale_fill_discrete(name='Contains\nAlternative\nBase') +
    theme_ridges() + theme(axis.text.y=element_text(family="mono"))
ggplot(dnDat, aes(x=Signal, y=Kmer, height=Density, fill=Sample)) +
    geom_ridgeline(alpha=0.4, size=0, color='white') +
    scale_fill_discrete(name='Contains\nAlternative\nBase') +
    theme_ridges() + theme(axis.text.y=element_text(family="mono"))
foo <- dev.off()


## plot alternative densities in k-mers without the alternative base of interest
noAltBaseDiffs <- sDiffs[!str_detect(names(sDiffs), altBase)]

upDat <- do.call(rbind.data.frame, lapply(names(head(noAltBaseDiffs, 20)), function(kmer) sAllDat[[kmer]]))
dnDat <- do.call(rbind.data.frame, lapply(names(tail(noAltBaseDiffs, 20)), function(kmer) sAllDat[[kmer]]))

pdf(paste0(densBase, '.noAlt.density.pdf'), width=10)
ggplot(upDat, aes(x=Signal, y=Kmer, height=Density, fill=Sample)) +
    geom_ridgeline(alpha=0.4, size=0, color='white') +
    scale_fill_discrete(name='Contains\nAlternative\nBase') +
    theme_ridges() + theme(axis.text.y=element_text(family="mono"))
ggplot(dnDat, aes(x=Signal, y=Kmer, height=Density, fill=Sample)) +
    geom_ridgeline(alpha=0.4, size=0, color='white') +
    scale_fill_discrete(name='Contains\nAlternative\nBase') +
    theme_ridges() + theme(axis.text.y=element_text(family="mono"))
foo <- dev.off()


singleAltBaseDiffs <- sDiffs[str_count(names(sDiffs), altBase) == 1]

upDat <- do.call(rbind.data.frame, lapply(names(head(singleAltBaseDiffs, 20)), function(kmer) sAllDat[[kmer]]))
dnDat <- do.call(rbind.data.frame, lapply(names(tail(singleAltBaseDiffs, 20)), function(kmer) sAllDat[[kmer]]))

pdf(paste0(densBase, '.singleAlt.density.pdf'), width=10)
ggplot(upDat, aes(x=Signal, y=Kmer, height=Density, fill=Sample)) +
    geom_ridgeline(alpha=0.4, size=0, color='white') +
    scale_fill_discrete(name='Contains\nAlternative\nBase') +
    theme_ridges() + theme(axis.text.y=element_text(family="mono"))
ggplot(dnDat, aes(x=Signal, y=Kmer, height=Density, fill=Sample)) +
    geom_ridgeline(alpha=0.4, size=0, color='white') +
    scale_fill_discrete(name='Contains\nAlternative\nBase') +
    theme_ridges() + theme(axis.text.y=element_text(family="mono"))
foo <- dev.off()


onePlusAltBaseDiffs <- sDiffs[str_count(names(sDiffs), altBase) > 0]

upDat <- do.call(rbind.data.frame, lapply(names(head(onePlusAltBaseDiffs, 20)), function(kmer) sAllDat[[kmer]]))
dnDat <- do.call(rbind.data.frame, lapply(names(tail(onePlusAltBaseDiffs, 20)), function(kmer) sAllDat[[kmer]]))

pdf(paste0(densBase, '.onePlusAlt.density.pdf'), width=10)
ggplot(upDat, aes(x=Signal, y=Kmer, height=Density, fill=Sample)) +
    geom_ridgeline(alpha=0.4, size=0, color='white') +
    scale_fill_discrete(name='Contains\nAlternative\nBase') +
    theme_ridges() + theme(axis.text.y=element_text(family="mono"))
ggplot(dnDat, aes(x=Signal, y=Kmer, height=Density, fill=Sample)) +
    geom_ridgeline(alpha=0.4, size=0, color='white') +
    scale_fill_discrete(name='Contains\nAlternative\nBase') +
    theme_ridges() + theme(axis.text.y=element_text(family="mono"))
foo <- dev.off()


## plot estimated shift correction due to high mod content samples
getMedMean <- function(x, sampType){
    sampDat <- x[x$Sample == sampType,]
    densCum <- cumsum(sampDat$Density)
    return(c(sampDat$Signal[which.min(abs(densCum - (tail(densCum, 1) / 2)))],
             weighted.mean(sampDat$Signal, sampDat$Density)))
}

standDiffs <- do.call(rbind.data.frame, lapply(sAllDat, function(x){
    stdMedMean <- getMedMean(x, 'Standard')
    altMedMean <- getMedMean(x, 'Alternative')
    data.frame(stdMed=stdMedMean[1],
               altMed=altMedMean[1],
               stdMean=stdMedMean[2],
               altMean=altMedMean[2],
               kmer=x$Kmer[1],
               hasAltBase=str_detect(x$Kmer[1], altBase))}))
standDiffs$MedDiff <- standDiffs$stdMed - standDiffs$altMed
standDiffs$MeanDiff <- standDiffs$stdMean - standDiffs$altMean

pdf(paste0('signal_shifts.', densBase, '.pdf'))
ggplot(standDiffs[!standDiffs$hasAltBase,]) + geom_point(aes(x=stdMed, y=MedDiff), alpha=0.3) +
    geom_smooth(aes(x=stdMed, y=MedDiff), color='red', method = "lm", formula = y ~ x + I(x^2)) + theme_bw()
ggplot(standDiffs[!standDiffs$hasAltBase,]) + geom_point(aes(x=stdMean, y=MeanDiff), alpha=0.3) +
    geom_smooth(aes(x=stdMean, y=MeanDiff), color='red', method = "lm", formula = y ~ x + I(x^2)) + theme_bw()
ggplot(standDiffs) + geom_point(aes(x=stdMed, y=MedDiff, color=hasAltBase), alpha=0.3) +
    geom_smooth(aes(x=stdMed, y=MedDiff, color=hasAltBase), method = "lm", formula = y ~ x + I(x^2)) +  theme_bw()
ggplot(standDiffs) + geom_point(aes(x=stdMean, y=MeanDiff, color=hasAltBase), alpha=0.3) +
    geom_smooth(aes(x=stdMean, y=MeanDiff, color=hasAltBase), method = "lm", formula = y ~ x + I(x^2)) +  theme_bw()
foo <- dev.off()

suppressPackageStartupMessages(library(dplyr))
suppressPackageStartupMessages(library(ggplot2))
suppressPackageStartupMessages(library(ggridges))

## set _DEBUG_PARAMS = True in resquiggle.py
## example run for min_obs_per_base testing:
##for i in {0..2}; do
##    testParam=`echo $i | awk '{print ($1 * 1) + 1}'`
##    tombo resquiggle param_test_reads/ genome.fasta \
##        --segmentation-parameters 5 3 $testParam 5 \
##        --signal-align-parameters 4.2 4.2 300 1500 20.0 40 750 2500 250 \
##        --processes 4
##done > param_values.txt


dat <- read.table('param_values.txt', header=TRUE)

## update with output from tombo.resquiggle._write_params_debug
colnames(dat) <- c(
    'running_window', 'min_obs_per_base', 'raw_min_obs_per_base',
    'mean_obs_per_event', 'match_evalue', 'skip_pen', 'bandwidth',
    'read_name', 'mean_score')

## filter out save bandwidth reads if bandwidth was not tested here
if(length(unique(dat$bandwidth))  == 2){
    dat <- dat %>% filter(bandwidth == min(as.numeric(dat$bandwidth)))
}

#3 convert params to factors and get stat that was investigated in this run
param_names <- setdiff(colnames(dat), c('mean_score', 'read_name'))
for(param_name in param_names){
    dat[,param_name] <- factor(dat[,param_name])
}
stat <- param_names[which.max(sapply(param_names, function(param_name)
    length(unique(dat[,param_name]))))]

## take min score over same read with same params (over re-scalings)
dat <- dat %>% group_by_at(c(param_names, 'read_name')) %>%
    summarize(mean_score=min(mean_score))

## filter for reads included in all parameter groups
rdat <- dat %>% group_by(read_name) %>% summarize(nreads=n())
maxNReads <- rdat$read_name[which(rdat$nreads == max(rdat$nreads))]
fdat <- dat %>% filter(read_name %in% maxNReads)

## compute and print mean and median stats for plotting
sumDat <- dat %>% group_by_at(stat) %>%
    summarize(med=median(mean_score), mean=mean(mean_score))
sumFDat <- fdat %>% group_by_at(stat) %>%
    summarize(med=median(mean_score), mean=mean(mean_score))

sumDat %>% print.data.frame(digits=6)
sumFDat %>% print.data.frame(digits=6)

pdf(paste0('param_values.', stat, '.pdf'), width=10)
ggplot(dat, aes_string(y=stat, x='mean_score', fill=stat)) +
    geom_vline(aes(xintercept=min(sumDat$med))) +
    geom_density_ridges(alpha=0.3, cex=0.5) +
    geom_point(aes_string(x='med', y=stat),
               color='red', size=5, data=sumDat) +
    geom_point(aes_string(x='mean', y=stat),
               color='orange', size=5, data=sumDat) +
    theme_minimal() + theme(legend.position="none") +
    coord_cartesian(xlim=quantile(dat$mean_score, c(0.01, 0.98)))
ggplot(fdat, aes_string(y=stat, x='mean_score', fill=stat)) +
    geom_vline(aes(xintercept=min(sumFDat$med))) +
    geom_density_ridges(alpha=0.3, cex=0.5) +
    geom_point(aes_string(x='med', y=stat),
               color='red', size=5, data=sumFDat) +
    geom_point(aes_string(x='mean', y=stat),
               color='orange', size=5, data=sumFDat) +
    theme_minimal() + theme(legend.position="none") +
    coord_cartesian(xlim=quantile(fdat$mean_score, c(0.01, 0.98)))
foo <- dev.off()

plotFit <- function(fitDat, readBw){
    for(reg in unique(fitDat$Region)){
        regDat <- fitDat[fitDat$Region == reg,]
        p1 <- ggplot(regDat) +
            geom_line(aes(x=EventPos, y=EventScore), size=0.1) +
            ggtitle(regDat$Region) + theme_minimal() +
            #geom_hline(aes(yintercept=yint), data=data.frame(yint=c(-4)),
            #           color='red') +
            #ylim(c(-15,5)) +
            theme(axis.title.x=element_blank())
        p2 <- ggplot(regDat) +
            geom_hline(aes(yintercept=readBw / 2), color='blue') +
            geom_line(aes(x=EventPos, y=BandPos), size=0.5) +
            theme_minimal() + ylim(c(0, readBw)) +
            theme(axis.title.x=element_blank())
        p3 <- ggplot(regDat) +
            geom_line(aes(x=EventPos, y=ModelMean), size=0.1, color='blue') +
            geom_line(aes(x=EventPos, y=EventMean), size=0.1) +
            theme_minimal()
        print(plot_grid(p1, p2, p3, align='v', ncol=1, rel_heights=c(7,6,7)))
    }
}

numModelVals <- 20
pseudoQuants <- seq(1/numModelVals,1-(1/numModelVals),
                    1/numModelVals)

plotMotifStats <- function(PlotDat, BaseDat, StatsDat,
                           ModelDat, AltModelDat=NULL){
    ylim <- 4
    regions <- unique(PlotDat$Region)
    midReg <- regions[(length(regions) + 1) / 2]
    ## "ggplot_gtable(ggplot_build(" writes a page so sink it to dev null
    pdf('/dev/null')
    ps <- lapply(regions, function(region){
        rBaseDat <- BaseDat[BaseDat$Region==region,]
        rPlotDat <- PlotDat[PlotDat$Region==region,]
        ## randomize so all of one group isn't on top
        sRPlotDat <- split(rPlotDat, rPlotDat$Read)
        rPlotDat <- do.call(rbind.data.frame, sample(sRPlotDat))
        # plot signal and distribution
        p <- ggplot(rPlotDat)
        if(! is.null(ModelDat)){
            rModelDat <- ModelDat[ModelDat$Region==region,]
            modDensDat <- lapply(split(
                rModelDat, paste0(rModelDat$Position,
                                  rModelDat$Strand)),
                function(psDat){
                    psDens <- density(qnorm(
                        pseudoQuants, mean=psDat$Mean[1], sd=psDat$SD[1]))
                    nDens <- length(psDens$x)
                    data.frame(Position=psDens$y,
                               Signal=psDens$x,
                               Strand=rep(psDat$Strand[1], nDens),
                               gPos=rep(psDat$Position[1], nDens),
                               Group=rep(psDat$Region[1], nDens))
                })
            maxDens <- max(unlist(lapply(modDensDat, function(x) x$Position)))
            if(! is.null(AltModelDat)) {
                rAltModelDat <- AltModelDat[AltModelDat$Region==region,]
                altModDensDat <- lapply(split(
                    rAltModelDat, paste0(rAltModelDat$Position,
                                         rAltModelDat$Strand)),
                    function(psDat){
                        psDens <- density(qnorm(
                            pseudoQuants, mean=psDat$Mean[1], sd=psDat$SD[1]))
                        nDens <- length(psDens$x)
                        data.frame(Position=psDens$y,
                                   Signal=psDens$x,
                                   Strand=rep(psDat$Strand[1], nDens),
                                   gPos=rep(psDat$Position[1], nDens),
                                   Group=rep(psDat$Region[1], nDens))
                    })
                altMaxDens <- max(unlist(lapply(
                    altModDensDat, function(x) x$Position)))
                maxDens <- max(altMaxDens, maxDens)
            }
            normDensDat <- do.call(
                rbind.data.frame,
                lapply(modDensDat, function(posDens){
                    data.frame(Position=(posDens$Position / maxDens) +
                                   posDens$gPos[1],
                               Signal=posDens$Signal,
                               Strand=posDens$Strand,
                               gPos=posDens$gPos,
                               Group=posDens$Group)
                }))
            p <- p + geom_polygon(aes(x=Position, y=Signal, group=gPos),
                                  data=normDensDat, fill='black', alpha=0.5,
                                  size=0, show.legend=FALSE)
            if(! is.null(AltModelDat)) {
                normAltDensDat <- do.call(
                    rbind.data.frame,
                    lapply(altModDensDat, function(posDens){
                        data.frame(Position=(posDens$Position / maxDens) +
                                       posDens$gPos[1],
                                   Signal=posDens$Signal,
                                   Strand=posDens$Strand,
                                   gPos=posDens$gPos,
                                   Group=posDens$Group)
                    }))
                p <- p + geom_polygon(aes(x=Position, y=Signal, group=gPos),
                                      data=normAltDensDat, fill='red', alpha=0.5,
                                      size=0, show.legend=FALSE)
            }
        }
        p <- p + geom_path(aes(x=Position, y=Signal, color=Group, group=Read),
                           alpha=0.5, size=0.1, show.legend=FALSE)
        p <- p + geom_text(
                     aes(x=Position+0.5, y=-ylim,label=Base, color=Base),
                     data=rBaseDat,
                     vjust=0, hjust=0.5, size=3, show.legend=FALSE) +
            scale_color_manual(
                values=c(
                    'A'='#00CC00', 'C'='#0000CC', 'G'='#FFB300',
                    'T'='#CC0000', '-'='black', 'N'='black',
                    'Group1'='red', 'Group2'='black')) +
            geom_vline(
                xintercept=min(rBaseDat$Position):
                (max(rBaseDat$Position) + 1), size=0.01) +
           scale_x_continuous(expand=c(0,0)) +
           coord_cartesian(ylim=c(-ylim, ylim)) +
           theme_bw() +
           theme(axis.text.x=element_blank(),
                 axis.text.y=element_blank(),
                 axis.title.x=element_blank(),
                 axis.ticks.x=element_blank(),
                 axis.ticks.y=element_blank(),
                 plot.margin=margin(0,0,0,0,'lines'),
                 panel.grid.major.x=element_blank(),
                 panel.grid.minor.x=element_blank(),
                 panel.grid.major.y=element_blank(),
                 panel.grid.minor.y=element_blank())
        if(region != midReg){
            p <- p + theme(axis.title.y=element_blank())
        }
        return(ggplot_gtable(ggplot_build(p)))
    })

    maxStat <- max(StatsDat$Stat)
    if(maxStat <= 1){ tickVals <- c(0,0.2,0.4,0.6,0.8,1)
    } else if(maxStat < 10){ tickVals <- seq(0,10,by=2)
    } else { tickVals <- seq(0,100,by=5) }
    ps[[length(ps) + 1]] <- ggplot_gtable(ggplot_build(
        ggplot(StatsDat) +
        geom_violin(aes(
            x=Position+0.5, y=Stat,
            group=cut_width(Position, 0.9999)), size=0.1, fill='black') +
        scale_x_continuous(expand=c(0,0)) +
        scale_y_continuous(breaks=tickVals) +
        theme_bw() +
        theme(axis.text.x=element_blank(),
              axis.ticks.x=element_blank(),
              axis.title.x=element_blank(),
              panel.grid.minor.y=element_blank()) +
        ylab('Fraction Modified or -log10(p-value)')))
    maxWidth <- do.call(grid::unit.pmax,
                        sapply(ps, function(x) x$widths[1:4]))
    ps <- lapply(ps, function(p){
        p$widths[1:4] <- maxWidth
        return(p)})
    # close dev null sink
    foo <- dev.off()
    do.call(
        grid.arrange,
        c(ps, list(ncol=1, heights=c(rep(1, length(regions)), 3))))
    ##library(cowplot)
    ##print(do.call(
    ##    plot_grid,
    ##    c(ps, list(ncol=1, align='v',
    ##               rel_heights=c(rep(1, length(regions)), 3)))))
}

minDPScore <- -250

plotDP <- function(dpDat, tbDat){
    for(reg in unique(dpDat$Region)){
        regDat <- dpDat[dpDat$Region == reg,]
        regDat$Score[regDat$Score < minDPScore] <- minDPScore
        mp <- mean(range(regDat$Score[grepl(reg, regDat$Region)]))
        if (grepl('fwd', reg)){
            tbReg <- tbDat[tbDat$Region == reg,]
            print(ggplot(regDat) +
                  geom_tile(aes(x=EventPos, y=SeqPos, fill=Score)) +
                  scale_fill_gradient2(high='#67001f', mid='#ffffbf',
                                       low='#1a1a1a', midpoint=mp) +
                  geom_line(aes(x=EventPos, y=SeqPos),
                            data=tbReg, color='steelblue') +
                  theme_minimal() + xlab('Segmented Signal') +
                  ylab('Genomic Sequence') + ggtitle(tbDat$Region[1]))
        } else {
            print(ggplot(regDat) +
                  geom_tile(aes(x=EventPos, y=SeqPos, fill=Score)) +
                  scale_fill_gradient2(high='#67001f', mid='#ffffbf',
                                       low='#1a1a1a', midpoint=mp) +
                  theme_minimal() + xlab('Segmented Signal') +
                  ylab('Genomic Sequence') + ggtitle(regDat$Region[1]))
        }
    }
}

plotROC <- function(rocDat){
    print(ggplot(rocDat) + geom_abline(slope=1, intercept=0) +
          geom_path(aes(x=FP, y=TP, color=Comparison)) + theme_bw() +
          xlab('False Positive Rate') + ylab('True Positive Rate'))
    print(ggplot(rocDat) +
          geom_path(aes(x=TP, y=Precision, color=Comparison)) + theme_bw() +
          xlab('Recall') + ylab('Precision'))
}

## should check if the stat is p-values, but this won't effect that
## so not fixing it now
lhRatioMax <- 25

plotROCPerRead <- function(rocDat, denStats){
    print(ggplot(rocDat) + geom_abline(slope=1, intercept=0) +
          geom_path(aes(x=FP, y=TP, color=Comparison)) + theme_bw() +
          xlab('False Positive Rate') + ylab('True Positive Rate'))
    print(ggplot(rocDat) +
          geom_path(aes(x=TP, y=Precision, color=Comparison)) + theme_bw() +
          xlab('Recall') + ylab('Precision'))
    for(modName in names(denStats)){
        denStats[[modName]]$stat[denStats[[modName]]$stat >
                                 lhRatioMax] <- lhRatioMax
        denStats[[modName]]$stat[denStats[[modName]]$stat <
                                 -lhRatioMax] <- -lhRatioMax
        print(ggplot(denStats[[modName]]) +
              geom_density(aes(x=stat, fill=motif_match),
                           alpha=0.5, color='white', size=0.01) +
              theme_bw() + ggtitle(modName) +
              scale_fill_discrete(name="Ground Truth\nModified"))
    }
}

plotSingleRead <- function(sigDat, vlineDat, hDat, hrDat, stDat){
    sigDat$Position <- sigDat$Position / 1000
    vlineDat$Position <- vlineDat$Position / 1000
    p <- ggplot(sigDat) +
        geom_vline(aes(xintercept=Position),
                   data=vlineDat, color='red', size=5) +
        geom_path(aes(x=Position, y=Signal), size=0.3) +
        theme_bw() +
        theme(axis.text=element_text(size=24),
              axis.title=element_text(size=28)) +
        xlab('Position (1000 raw obs.)') + ylim(-5,5)
    if(! is.null(hDat)){
        hDat$Position <- hDat$Position / 1000
        p <- p + geom_point(aes(x=Position, y=Signal),
                            data=hDat, color='red', size=2)
    }
    if(! is.null(hrDat)){
        hrDat$Position <- hrDat$Position / 1000
        hrDat$PositionEnd <- hrDat$PositionEnd / 1000
        p <- p +
            geom_rect(aes(xmin=Position, xmax=PositionEnd, ymin=-Inf, ymax=Inf),
                      data=hrDat, fill='red', alpha=0.3, color=NA)
    }
    if(is.null(stDat)){
        print(p)
    } else {
        stDat$Position <- stDat$Position / 1000
        p2 <- ggplot(stDat) + geom_line(aes(x=Position, y=Value)) + theme_bw()
        if(! is.null(hrDat)){
            p2 <- p2 +
                geom_rect(aes(xmin=Position, xmax=PositionEnd,
                              ymin=-Inf, ymax=Inf),
                          data=hrDat, fill='red', alpha=0.3, color=NA)
        }
        print(plot_grid(p, p2, ncol=1, align='v'))
    }
}

library(ggplot2)

scaleFactor <- 4
scaleFactor2 <- 3
scalePower <- 0.2

firstMean <- 0
secondMeans <- seq(0.05, 0.8, 0.05)
constVar <- 0.12

xlims <- c(-2,2)

pdf('llr_test.pdf', width=10)
for (secondMean in secondMeans){
    secondMean <- firstMean + secondMean
    test_vals <- seq(xlims[1], xlims[2], 0.05)

    ref_diffs <- test_vals - firstMean
    alt_diffs <- test_vals - secondMean
    scale_diffs <- test_vals - ((firstMean + secondMean) / 2)
    space_btwn <- (firstMean - secondMean)^2

    dat <- rbind.data.frame(
        data.frame(value=log(dnorm(test_vals, firstMean) / dnorm(test_vals, secondMean)), x=test_vals,
                   type='Log Likelihood Ratio'),
        data.frame(value=exp(-(scale_diffs^2) / (scaleFactor * constVar)) * ((alt_diffs)^2 - (ref_diffs)^2) /
                       (constVar * space_btwn^scalePower * scaleFactor2), x=test_vals,
                   type='Outlier-Robust LLR'),
        data.frame(value=dnorm(test_vals, firstMean, sqrt(constVar)), x=test_vals, type='Canonical Expected\nSignal Level'),
        data.frame(value=dnorm(test_vals, secondMean, sqrt(constVar)), x=test_vals, type='Alternative Expected\nSignal Level')
        )

    print(ggplot(dat) + geom_density(aes(x=x, y=value, fill=type), stat='identity', color='white', size=0, alpha=0.3) +
          theme_bw() + ggtitle(paste('Expected Signal Level Difference:', secondMean)) + ylim(-2,2) + xlim(xlims[1],xlims[2]))
}
foo <- dev.off()

library(dplyr)
library(ggplot2)

## set _DEBUG_BANDWIDTH = True (or _DEBUG_START_BANDWIDTH) in resquiggle.py
##   tombo resquiggle bandwidth_test_reads/ genome.fasta --processes 8 > band_boundary_tuning.txt


dat <- read.table('band_boundary_tuning.txt', header=TRUE)

std_bw <- names(sort(table(dat$bandwidth), decreasing=TRUE))[1]
print(std_bw)

pdf('band_boundary_tuning.pdf', width=11)
ggplot(dat %>% filter(bandwidth == std_bw)) +
    geom_density(aes(x=min_bw_edge_buffer), fill='black') + theme_bw()
foo <- dev.off()


## print bandwidth values for each percentile of reads included in that bandwidth
print(((as.numeric(std_bw) / 2) -
 quantile(dat$min_bw_edge_buffer,
          c(0.01, 0.05, 0.1, 0.2, 0.25, 0.5))) * 2)

## inverse for selected bw
sel_bw <- 200
1 - ecdf(dat$min_bw_edge_buffer)((as.numeric(std_bw) / 2) - (sel_bw / 2))




## for start benadwidth debugging
## print bandwidth values for each percentile of reads included in that bandwidth
print(
    quantile(dat$min_bw_edge_buffer,
             1 - c(0.01, 0.05, 0.1, 0.2, 0.25, 0.5)))

## inverse for selected bw
sel_bw <- 750
ecdf(dat$min_bw_edge_buffer)(sel_bw)

boxQuants <- c(0.01,0.25,0.5,0.75,0.99)
quantQuants <- c(0.01,0.1,0.2,0.3,0.4)

plotModelComp <- function(sigDat, quantDat, boxDat, eventDat,
                          baseDat, TitleDat, modelDat, altModelDat=NULL,
                          numModelVals=20){
    pseudoQuants <- seq(1/numModelVals,1-(1/numModelVals),
                        1/numModelVals)
    ## fix 0 baased coordinates passed in
    sigDat$Position <- sigDat$Position + 1
    quantDat$Position <- quantDat$Position + 1
    boxDat$Position <- boxDat$Position + 1
    eventDat$Position <- eventDat$Position + 1
    baseDat$Position <- baseDat$Position + 1
    modelDat$Position <- modelDat$Position + 1
    if(!is.null(altModelDat)){
        altModelDat$Position <- altModelDat$Position + 1
    }
    regions <- sort(c(unique(as.character(sigDat$Region)),
                      unique(as.character(quantDat$Region)),
                      unique(as.character(boxDat$Region)),
                      unique(as.character(eventDat$Region))))
    for(reg_i in regions){
        reg_model_dat <- modelDat[modelDat$Region==reg_i,]
        reg_has_alt <- FALSE
        if(!is.null(altModelDat)){
            reg_alt_model_dat <- altModelDat[altModelDat$Region==reg_i,]
            reg_has_alt = nrow(reg_alt_model_dat) > 0
        }
        reg_base_dat <- baseDat[baseDat$Region==reg_i,]
        title <- TitleDat[TitleDat$Region==reg_i,'Title']
        if(reg_i %in% sigDat$Region){
            modDensDat <- lapply(split(
                reg_model_dat, paste0(reg_model_dat$Position,
                                      reg_model_dat$Strand)),
                function(psDat){
                    psDens <- density(qnorm(
                        pseudoQuants, mean=psDat$Mean[1], sd=psDat$SD[1]))
                    nDens <- length(psDens$x)
                    data.frame(Position=psDens$y,
                               Signal=psDens$x,
                               Strand=rep(psDat$Strand[1], nDens),
                               gPos=rep(psDat$Position[1], nDens),
                               Group=rep(psDat$Region[1], nDens))
                })
            if(reg_has_alt){
                altModDensDat <- lapply(split(
                    reg_alt_model_dat, paste0(reg_alt_model_dat$Position,
                                              reg_alt_model_dat$Strand)),
                    function(psDat){
                        psDens <- density(qnorm(
                            pseudoQuants, mean=psDat$Mean[1], sd=psDat$SD[1]))
                        nDens <- length(psDens$x)
                        data.frame(Position=psDens$y,
                                   Signal=psDens$x,
                                   Strand=rep(psDat$Strand[1], nDens),
                                   gPos=rep(psDat$Position[1], nDens),
                                   Group=rep(psDat$Region[1], nDens))
                    })
                maxDens <- max(unlist(c(
                    lapply(modDensDat, function(x) x$Position),
                    lapply(altModDensDat, function(x) x$Position))))
            } else {
                maxDens <- max(unlist(lapply(
                    modDensDat, function(x) x$Position)))
            }
            normDensDat <- do.call(
                rbind.data.frame,
                lapply(modDensDat, function(posDens){
                    data.frame(Position=(posDens$Position / maxDens) +
                                   posDens$gPos[1],
                               Signal=posDens$Signal,
                               Strand=posDens$Strand,
                               gPos=posDens$gPos,
                               Group=posDens$Group)
                }))
            reg_sig_dat <- sigDat[sigDat$Region == reg_i,]
            base_pos <- min(reg_sig_dat$Signal)
            p <- ggplot(reg_sig_dat) +
                geom_polygon(aes(x=Position, y=Signal, group=gPos),
                             data=normDensDat, fill='black', alpha=0.4,
                             size=0, show.legend=FALSE)
            if(reg_has_alt){
                altNormDensDat <- do.call(
                    rbind.data.frame,
                    lapply(altModDensDat, function(posDens){
                        data.frame(Position=(posDens$Position / maxDens) +
                                       posDens$gPos[1],
                                   Signal=posDens$Signal,
                                   Strand=posDens$Strand,
                                   gPos=posDens$gPos,
                                   Group=posDens$Group)
                    }))
                p <- p +
                    geom_polygon(aes(x=Position, y=Signal, group=gPos),
                                 data=altNormDensDat, fill='red', alpha=0.4,
                                 size=0, show.legend=FALSE)
            }
            p <- p + geom_path(
                         aes(x=Position, y=Signal, color=Group, group=Read),
                         alpha=0.3, size=0.2, show.legend=FALSE)
        } else if(reg_i %in% quantDat$Region) {
            reg_model_dat <- do.call(
                rbind.data.frame,
                lapply(split(
                    reg_model_dat, paste0(reg_model_dat$Position,
                                          reg_model_dat$Strand)),
                    function(psDat){
                        do.call(rbind.data.frame,
                                lapply(quantQuants, function(x){
                                    psQuantVals <- qnorm(
                                        c(x,1-x), mean=psDat$Mean[1],
                                        sd=psDat$SD[1])
                                    data.frame(
                                        Position=psDat$Position[1] + 0.4,
                                        Strand=psDat$Strand[1],
                                        Group='Model',
                                        Region=psDat$Region[1],
                                        Lower=psQuantVals[1],
                                        Upper=psQuantVals[2])}))
                    }))
            reg_quant_dat <- rbind.data.frame(
                quantDat[quantDat$Region == reg_i,],
                reg_model_dat)
            base_pos <- min(reg_quant_dat$Lower)
            p <- ggplot(reg_quant_dat) +
                geom_rect(aes(xmin=Position+0.1, xmax=Position + 0.5,
                              ymin=Lower, ymax=Upper, fill=Group),
                          alpha=0.1, show.legend=FALSE) +
                ylab('Signal') + xlab('Position')
        } else if (reg_i %in% boxDat$Region) {
            reg_model_dat <- do.call(
                rbind.data.frame,
                lapply(
                    split(
                        reg_model_dat, paste0(reg_model_dat$Position,
                                              reg_model_dat$Strand)),
                    function(psDat){
                        psBoxVals <- qnorm(
                            boxQuants, mean=psDat$Mean[1], sd=psDat$SD[1])
                        data.frame(Position=psDat$Position[1],
                                   Strand=psDat$Strand[1],
                                   Group='Model',
                                   Region=psDat$Region[1],
                                   SigMin=psBoxVals[1],
                                   Sig25=psBoxVals[2],
                                   SigMed=psBoxVals[3],
                                   Sig75=psBoxVals[4],
                                   SigMax=psBoxVals[5])
                    }))
            reg_box_dat <- rbind.data.frame(
                boxDat[boxDat$Region == reg_i,],
                reg_model_dat)
            base_pos <- min(reg_box_dat$SigMin)
            p <- ggplot(reg_box_dat) +
                geom_boxplot(
                    aes(Position + 0.5, ymin=SigMin, lower=Sig25,
                        middle=SigMed, upper=Sig75, ymax=SigMax,
                        fill=Group), size=0.2, alpha=0.3,
                    stat="identity", show.legend=FALSE) +
                ylab('Signal') + xlab('Position')
        } else {
            reg_model_dat <- do.call(
                rbind.data.frame,
                lapply(
                    split(
                        reg_model_dat, paste0(reg_model_dat$Position,
                                              reg_model_dat$Strand)),
                    function(psDat){
                        psPsuedoEvents <- qnorm(
                            pseudoQuants, mean=psDat$Mean[1], sd=psDat$SD[1])
                        nObs <- length(psPsuedoEvents)
                        data.frame(Position=rep(psDat$Position[1], nObs),
                                   Signal=psPsuedoEvents,
                                   Strand=rep(psDat$Strand[1], nObs),
                                   Group=rep('Model', nObs),
                                   Region=rep(psDat$Region[1], nObs))
                    }))
            reg_event_dat <- rbind.data.frame(
                eventDat[eventDat$Region == reg_i,],
                reg_model_dat)
            base_pos <- min(reg_event_dat$Signal)
            ## convert event data to be back to back densities instead
            ## of side by side violins
            g1 <- reg_event_dat$Group[1]
            densDat <- lapply(split(
                reg_event_dat, paste0(reg_event_dat$Group,
                                      reg_event_dat$Position,
                                      reg_event_dat$Strand)),
                              function(pgDat){
                                  pgDens <- density(pgDat$Signal)
                                  nDens <- length(pgDens$x)
                                  data.frame(Position=pgDens$y,
                                             Signal=pgDens$x,
                                             Strand=rep(pgDat$Strand[1], nDens),
                                             gPos=rep(pgDat$Position[1], nDens),
                                             Group=rep(pgDat$Group[1], nDens))
                              })
            maxDens <- max(unlist(lapply(densDat, function(x) x$Position)))
            normDensDat <- do.call(
                rbind.data.frame,
                lapply(densDat, function(posDens){
                    pos <- ifelse(posDens$Group == g1, posDens$Position * -1,
                                  posDens$Position) / (maxDens * 2)
                    data.frame(Position=pos + posDens$gPos[1],
                               Signal=posDens$Signal,
                               Strand=posDens$Strand,
                               gPos=posDens$gPos,
                               Group=posDens$Group)
                }))
            p <- ggplot(normDensDat) +
                geom_polygon(aes(x=Position + 0.5, y=Signal, fill=Group,
                                 group=paste0(Group, gPos)),
                             size=0, show.legend=FALSE) +
                ylab('Signal') + xlab('Position')
        }
        print(p + facet_grid(Strand ~ .) +
              geom_text(
                  aes(x=Position+0.5, y=base_pos, label=Base, color=Base),
                  data=reg_base_dat, hjust=0.5, size=3, show.legend=FALSE,
                  vjust=ifelse(reg_base_dat$Strand=='Forward Strand',0,1),
                  angle=ifelse(reg_base_dat$Strand=='Forward Strand',0,180)) +
              scale_color_manual(
                  values=c(
                      'A'='#00CC00', 'C'='#0000CC', 'G'='#FFB300',
                      'T'='#CC0000', 'U'='#CC0000', '-'='black', 'N'='black',
                      'Group1'='red', 'Model'='black')) +
              scale_fill_manual(
                  values=c('Group1'='red', 'Model'='black')) +
              geom_vline(
                  xintercept=
                      min(reg_base_dat$Position):
                  (max(reg_base_dat$Position) + 1),
                  size=0.01) +
              ggtitle(title) +
              theme_bw() + theme(axis.text.x=element_text(hjust=0),
                                 panel.grid.major.x=element_blank(),
                                 panel.grid.minor.x=element_blank(),
                                 panel.grid.minor.y=element_blank()))
    }}

minDPScore <- -250

plotRawDP <- function(zDat, fwdDat, tbDat, sigDat){
    for(reg in unique(zDat$Region)){
        tbReg <- tbDat[tbDat$Region == reg,]

        regZDat <- zDat[zDat$Region == reg,]
        regZDat$Score[regZDat$Score < minDPScore] <- minDPScore
        zP <- ggplot(regZDat) +
            geom_tile(aes(x=EventPos, y=SeqPos, fill=Score)) +
            scale_fill_gradient2(
                high='#67001f', mid='#ffffbf', low='#1a1a1a',
                midpoint=mean(range(regZDat$Score))) +
            geom_line(aes(x=EventPos, y=SeqPos),
                  data=tbReg, color='steelblue') +
            theme_minimal() + ylab('Genomic Sequence') +
            theme(axis.title.x=element_blank(), axis.text.x=element_blank()) +
            ggtitle(tbDat$Region[1]) +
            xlim(min(sigDat$Pos) - 1, max(sigDat$Pos) + 1)

        regFwdDat <- fwdDat[fwdDat$Region == reg,]
        regFwdDat$Score[regFwdDat$Score < minDPScore] <- minDPScore
        fP <- ggplot(regFwdDat) +
            geom_tile(aes(x=EventPos, y=SeqPos, fill=Score)) +
            scale_fill_gradient2(
                high='#67001f', mid='#ffffbf', low='#1a1a1a',
                midpoint=mean(range(regFwdDat$Score))) +
            geom_line(aes(x=EventPos, y=SeqPos),
                      data=tbReg, color='steelblue') +
            theme_minimal() + ylab('Genomic Sequence') +
            theme(axis.title.x=element_blank(), axis.text.x=element_blank()) +
            ggtitle(tbDat$Region[1]) +
            xlim(min(sigDat$Pos) - 1, max(sigDat$Pos) + 1)

        sP <- ggplot(sigDat) + geom_line(aes(x=Pos, y=Signal, color=0)) +
            theme_minimal() + xlab('Position') +
            xlim(min(sigDat$Pos) - 1, max(sigDat$Pos) + 1)

        print(plot_grid(zP, sP, align='v', ncol=1, rel_heights=c(5,1)))
        print(plot_grid(fP, sP, align='v', ncol=1, rel_heights=c(5,1)))
    }
}

# set thresholds for plotting tile
pointMaxReads <- 40
pointMaxBases <- 200
textLim <- 150

plotPerReadStats <- function(StatData, OrdData, baseDat, boxCenter, arePvals){
    all_reg_ids <- unique(StatData$Region)
    last_reg_id <- tail(all_reg_ids, 1)
    for(reg_i in all_reg_ids){
        regDat <- StatData[StatData$Region == reg_i,]
        regOrd <- OrdData[OrdData$Region == reg_i,'Read']
        regDat$Read <- factor(regDat$Read, ordered=TRUE, levels=regOrd)
        boxDat <- data.frame(xS=mean(range(regDat$Position))-1,
                             xE=mean(range(regDat$Position))+1,
                             yS=0.5, yE=length(unique(regDat$Read))+0.5)
        regDat <- regDat[!is.na(regDat$Stats),]
        reg_base_dat <- baseDat[baseDat$Region==reg_i,]
        p <- ggplot(regDat)
        ## add stat values
        if(arePvals){
            if(length(unique(regDat$Read)) > pointMaxReads ||
               length(unique(regDat$Position)) > pointMaxBases){
                p <- p + geom_tile(aes(x=Position, y=Read, fill=Stats))
            } else {
                p <- p + geom_point(
                             aes(x=Position, y=Read, fill=Stats),
                             stroke=0, color='#969696', size=5, shape=21)
            }
            p <- p +
                scale_fill_gradient2(
                    low="#ffffff", mid="#ffffff", high='#cb181d',
                    midpoint=0.1, name='-Log10\nP-Value')
        } else {
            if(length(unique(regDat$Read)) > pointMaxReads ||
               length(unique(regDat$Position)) > pointMaxBases){
                p <- p + geom_tile(aes(x=Position, y=Read, fill=Stats))
            } else {
                p <- p + geom_point(aes(x=Position, y=Read, fill=Stats),
                                    stroke=0, color='#969696', size=5, shape=21,
                                    alpha=0.5)
            }
            lhRatioMax <- max(abs(regDat$Stats))
            breaks <- seq(-lhRatioMax, lhRatioMax, length.out=5)
            p <- p +
                scale_fill_gradient2(
                    low="#b2182b", mid='#ffffff', high='#4d4d4d', midpoint=0,
                    name='Log\nLikelihood\nRatio\n', breaks=breaks,
                    labels=c('Alternative\nBase', breaks[2], '0',
                             breaks[4], 'Standard\nBase'))
        }
        ## add either text or tile-like base data
        if(nrow(reg_base_dat) > 0){
            if(nrow(reg_base_dat) < textLim){
                p <- p + geom_text(
                             aes(x=Position, y=0.5, label=Base, color=Base),
                             data=reg_base_dat, hjust=0.5, size=3,
                             show.legend=FALSE, vjust=1.2, angle=0)
            } else {
                p <- p + geom_point(
                             aes(x=Position, y=0, color=Base),
                             data=reg_base_dat, show.legend=FALSE, shape=15)
            }
        }
        if(boxCenter){
            p <- p + geom_rect(aes(xmin=xS, xmax=xE, ymin=yS, ymax=yE),
                               data=boxDat, fill=NA, color='black', size=0.2)
        }
        p <- p +
            scale_color_manual(
                values=c('A'='#00CC00', 'C'='#0000CC', 'G'='#FFB300',
                         'T'='#CC0000', '-'='black', 'N'='black')) +
            scale_x_continuous(expand=c(0, 0)) + ylab('Reads') +
            theme_minimal() +
            theme(panel.grid=element_blank(), axis.text.y=element_blank(),
                  axis.text.x=element_blank(), legend.text.align=0.5,
                  legend.title.align=0.5)
        ## need to set clip to off so bases aren't cut off
        gt <- ggplot_gtable(ggplot_build(p))
        gt$layout$clip[gt$layout$name == "panel"] <- "off"
        grid::grid.draw(gt)
        if(reg_i != last_reg_id){ grid::grid.newpage() }
    }
}

library(ggplot2)

a <- 0.5
b <- 2

mDat <- do.call(rbind.data.frame, lapply(1:20, function(i)
    data.frame(postProb=sapply(0:i, function(j) (a+i-j) / (a+i+b)), coverage=i, notMod=0:i)))

pdf('test_priors.pdf', width=8)
ggplot(mDat) + geom_tile(aes(x=coverage, y=notMod, fill=postProb)) +
    theme_bw() + scale_fill_gradient2(low='#67001f', mid='#f7f7f7', high='#2166ac', midpoint=0.5)
dev.off()

natDir='test_data/native_reads/'
ampDir='test_data/amplified_reads/'
rcsvDir='test_data/recursive_test/'
natFsq="test_data/fastqs.native.fasta"
natFqDir='test_data/native_reads.for_fastq_ann/'

nrModFn='../tombo/tombo/tombo_models/tombo.DNA.model'
altModFn='../tombo/tombo/tombo_models/tombo.DNA.5mC.model'
poreModel="r9_250bps.nucleotide.5mer.template.model"

genomeFn="e_coli.K12.NEB5alpha.fasta"
mmiFn="e_coli.K12.NEB5alpha.mmi"

genomeLocs='"CP017100.1:1505285" "CP017100.1:2873680"'
strandGenomeLocs='"CP017100.1:1505285:+" "CP017100.1:2873680:-"'

modLocsFn='modified_positions.bed'
unmodLocsFn='unmodified_positions.bed'

runHelps=false
runResquiggle=true

printf "********* Testing help commands **********\n"
tombo -h || { echo 'Main tombo help failed. Likely a syntax error.' ; exit 1; }

if [ $runHelps == true ]
then
tombo resquiggle -h

tombo preprocess annotate_raw_with_fastqs -h

tombo filter clear_filters -h
tombo filter stuck -h
tombo filter level_coverage -h
tombo filter q_score -h
tombo filter raw_signal_matching -h
tombo filter genome_locations -h

tombo detect_modifications de_novo -h
tombo detect_modifications alternative_model -h
tombo detect_modifications model_sample_compare -h
tombo detect_modifications level_sample_compare -h
tombo detect_modifications aggregate_per_read_stats -h

tombo text_output browser_files -h
tombo text_output signif_sequence_context -h

tombo plot max_coverage -h
tombo plot genome_locations -h
tombo plot motif_centered -h
tombo plot max_difference -h
tombo plot most_significant -h
tombo plot motif_with_stats -h
tombo plot per_read -h

tombo plot roc -h
tombo plot per_read_roc -h
tombo plot kmer -h
tombo plot cluster_most_significant -h

tombo build_model estimate_scale -h
tombo build_model event_resquiggle -h
tombo build_model estimate_reference -h
tombo build_model estimate_alt_reference -h
fi

if [ $runResquiggle == true ]
then
printf "\n\n********* Testing re-squiggle command **********\n"
tombo resquiggle \
      $natDir $genomeFn \
      --failed-reads-filename testing.native.failed_read.txt \
      --processes 8 --overwrite --num-most-common-errors 5
tombo resquiggle \
      $ampDir $genomeFn \
      --failed-reads-filename testing.amplified.failed_read.txt \
      --processes 8 --overwrite --num-most-common-errors 5

printf "\n\n********* Testing FASTQ annotation and re-squiggle **********\n"
tombo preprocess annotate_raw_with_fastqs --fast5-basedir $natFqDir \
      --fastq-filenames $natFsq --overwrite
tombo resquiggle \
      $natFqDir $genomeFn \
      --corrected-group FastqAnnotation \
      --processes 8 --overwrite

printf "\n\n********* Testing minimap2 index **********\n"
tombo resquiggle \
      $natDir $mmiFn \
      --corrected-group RawMinimapIndexCorrected \
      --processes 8 --overwrite

printf "\n\n********* Testing re-squiggle command with filename **********\n"
tombo resquiggle \
      $natDir $genomeFn --tombo-model-filename $nrModFn \
      --corrected-group RawWFilenameCorrected \
      --processes 8 --overwrite
tombo resquiggle \
      $ampDir $genomeFn --tombo-model-filename $nrModFn \
      --corrected-group RawWFilenameCorrected \
      --processes 8 --overwrite

printf "\n\n********* Testing event-based resquiggle **********\n"
tombo build_model event_resquiggle \
      $natDir $genomeFn --minimap2-executable ./minimap2 \
      --corrected-group RawEventCorrected --processes 8 --overwrite

printf "\n\n********* Testing pA normalization **********\n"
tombo build_model event_resquiggle \
      $natDir $genomeFn \
       --minimap2-executable ./minimap2 \
      --normalization-type pA_raw --processes 8 \
      --corrected-group RawGenomeCorrected_pA_raw_000 --overwrite
tombo build_model event_resquiggle \
      $natDir $genomeFn --minimap2-executable ./minimap2 \
      --normalization-type pA --pore-model-filename $poreModel \
      --corrected-group RawGenomeCorrected_pA_000 --overwrite \
      --processes 8

printf "\n\n********* Testing recursive resquiggle **********\n"
tombo resquiggle \
      $rcsvDir $genomeFn \
      --processes 8 --overwrite

printf "\n\n********* Testing re-squiggle length filters **********\n"
tombo resquiggle \
      $natDir $genomeFn \
      --corrected-group RawWLengthFilter \
      --signal-length-range 0 500000 \
      --sequence-length-range 0 35000 \
      --processes 8 --overwrite
fi

printf "\n\n********* Testing filter functions **********\n"
tombo filter clear_filters --fast5-basedirs $natDir
tombo filter stuck --fast5-basedirs $natDir \
      --obs-per-base-filter 99:200 100:1000
tombo filter level_coverage --fast5-basedirs $natDir \
      --percent-to-filter 10
tombo filter q_score --fast5-basedirs $natDir --q-score 10
tombo filter raw_signal_matching --fast5-basedirs $natDir \
      --signal-matching-score 0.75
tombo filter clear_filters --fast5-basedirs $natDir
tombo filter genome_locations --fast5-basedirs $natDir \
      --include-regions CP017100.1:1,485,920-1,558,736 --include-partial-overlap
tombo filter genome_locations --fast5-basedirs $natDir \
      --include-regions CP017100.1:1,485,920-1,558,736
tombo filter clear_filters --fast5-basedirs $natDir


printf "\n\n********* Testing estimate global scale function **********\n"
tombo build_model estimate_scale $natDir

printf "\n\n********* Testing single sample genome-anchored plotting functions **********\n"
tombo plot max_coverage --fast5-basedirs $natDir \
        --num-bases 21 --overplot-threshold 1000 \
        --pdf-filename testing.max_cov.1_samp.pdf
tombo plot genome_locations --fast5-basedirs $ampDir \
        --genome-locations $genomeLocs \
        --num-bases 21 --overplot-threshold 1000 \
        --pdf-filename testing.genome_loc.1_samp.pdf
tombo plot motif_centered --fast5-basedirs $natDir --motif ATC \
        --genome-fasta $genomeFn \
        --num-bases 21 --overplot-threshold 1000 \
        --pdf-filename testing.motif_centered.1_samp.pdf
tombo plot motif_centered --fast5-basedirs $natDir --motif TWA \
        --genome-fasta $genomeFn \
        --num-bases 21 --overplot-threshold 1000 \
        --pdf-filename testing.motif_centered.palindrome.1_samp.pdf
tombo plot motif_centered --fast5-basedirs $natDir --motif ATC \
        --genome-fasta $genomeFn \
        --num-bases 21 --overplot-threshold 1000 --deepest-coverage \
        --pdf-filename testing.motif_centered.deepest.1_samp.pdf
tombo plot motif_centered --fast5-basedirs $natDir --motif NNCCWGG \
      --plot-alternate-model 5mC --genome-fasta $genomeFn \
      --num-bases 21 --overplot-threshold 1000 \
      --pdf-filename testing.motif_centered.w_model.pdf
tombo plot max_coverage --fast5-basedirs $rcsvDir \
        --num-bases 21 --overplot-threshold 1000 \
        --pdf-filename testing.max_cov.1_samp.recursive.pdf


printf "\n\n********* Testing multiple sample genome-anchored plotting functions **********\n"
tombo plot max_coverage --fast5-basedirs $natDir \
        --control-fast5-basedirs $ampDir \
        --num-bases 21 --overplot-threshold 1000 \
        --pdf-filename testing.max_cov.2_samp.pdf
tombo plot genome_locations --fast5-basedirs $natDir \
        --control-fast5-basedirs $ampDir \
        --genome-locations $genomeLocs \
        --num-bases 21 --overplot-threshold 1000 \
        --pdf-filename testing.genome_loc.2_samp.pdf
tombo plot motif_centered --fast5-basedirs $natDir --motif ATC \
        --genome-fasta $genomeFn \
        --control-fast5-basedirs $ampDir \
        --num-bases 21 --overplot-threshold 1000 \
        --pdf-filename testing.motif_centered.2_samp.pdf
tombo plot motif_centered --fast5-basedirs $natDir --motif TWA \
        --genome-fasta $genomeFn \
        --control-fast5-basedirs $ampDir \
        --num-bases 21 --overplot-threshold 1000 \
        --pdf-filename testing.motif_centered.palindrome.2_samp.pdf
tombo plot motif_centered --fast5-basedirs $natDir --motif ATC \
        --genome-fasta $genomeFn \
        --control-fast5-basedirs $ampDir \
        --num-bases 21 --overplot-threshold 1000 --deepest-coverage \
        --pdf-filename testing.motif_centered.deepest.2_samp.pdf

printf "\n\n********* Testing statistical testing. **********\n"
rm test_stats.de_novo.tombo.stats test_stats.2samp.tombo.stats \
   test_stats.alt_model.5mC.tombo.stats \
   test_stats.alt_default_model.5mC.tombo.stats \
   test_stats.alt_default_model.6mA.tombo.stats \
   test_stats.de_novo.tombo.per_read_stats test_stats.2samp.tombo.per_read_stats \
   test_stats.alt_model.5mC.tombo.per_read_stats \
   test_stats.alt_default_model.5mC.tombo.per_read_stats \
   test_stats.alt_default_model.6mA.tombo.per_read_stats \
   test_standard.model test_stats.de_novo.new_thresh.tombo.stats \
   test_alt.model test_alt.use_densities.model \
   test_stats.alt_native.motif.dcm.tombo.stats \
   test_stats.alt_native.motif.dam.tombo.stats \
   test_stats.alt_amp_samp.motif.dcm.tombo.stats \
   test_stats.alt_amp_samp.motif.dam.tombo.stats
tombo detect_modifications de_novo --fast5-basedirs $natDir \
      --minimum-test-reads 5 \
      --statistics-file-basename test_stats.de_novo \
      --per-read-statistics-basename test_stats.de_novo
tombo detect_modifications de_novo --fast5-basedirs $natDir \
      --minimum-test-reads 5 --single-read-threshold 0.1 0.75 \
      --statistics-file-basename test_stats.de_novo.two_way_thresh \
      --per-read-statistics-basename test_stats.de_novo.two_way_thresh
tombo detect_modifications model_sample_compare --fast5-basedirs $natDir \
      --control-fast5-basedirs $ampDir \
      --minimum-test-reads 1 --sample-only-estimates \
      --statistics-file-basename test_stats.2samp \
      --per-read-statistics-basename test_stats.2samp
tombo detect_modifications model_sample_compare --fast5-basedirs $natDir \
      --control-fast5-basedirs $ampDir \
      --minimum-test-reads 5 \
      --statistics-file-basename test_stats.2samp_w_post \
      --per-read-statistics-basename test_stats.2samp_w_post
tombo detect_modifications level_sample_compare --fast5-basedirs $natDir \
      --alternate-fast5-basedirs $ampDir \
      --minimum-test-reads 5 \
      --statistics-file-basename test_stats.2samp_levels
tombo detect_modifications alternative_model --fast5-basedirs $natDir \
      --alternate-bases 5mC 6mA \
      --statistics-file-basename test_stats.alt_default_model \
      --per-read-statistics-basename test_stats.alt_default_model
tombo detect_modifications alternative_model --fast5-basedirs $natDir \
      --tombo-model-filename $nrModFn \
      --alternate-model-filenames $altModFn \
      --statistics-file-basename test_stats.alt_model \
      --per-read-statistics-basename test_stats.alt_model

printf "\n\n********* Testing model estimation. **********\n"
tombo build_model estimate_reference --fast5-basedirs $natDir \
      --tombo-model-filename test_standard.model \
      --upstream-bases 1 --downstream-bases 1 --minimum-kmer-observations 1
tombo build_model estimate_alt_reference --fast5-basedirs $natDir \
      --control-fast5-basedirs $ampDir \
      --tombo-model-filename test_standard.model \
      --alternate-model-filename test_alt.model \
      --alternate-model-name 5mC --alternate-model-base C \
      --minimum-kmer-observations 1 --save-density-basename test_save_dens
tombo build_model estimate_alt_reference \
      --alternate-density-filename test_save_dens.alternate_density.txt \
      --control-density-filename test_save_dens.control_density.txt \
      --tombo-model-filename test_standard.model \
      --alternate-model-filename test_alt.use_densities.model \
      --alternate-model-name 5mC --alternate-model-base C \
      --minimum-kmer-observations 1
tombo build_model estimate_motif_alt_reference --fast5-basedirs $natDir \
      --alternate-model-filename test_alt.motif_model \
      --alternate-model-name dcm --motif-description CCWGG:2 \
      --minimum-kmer-observations 1

printf "\n\n********* Testing aggregate per-read stats **********\n"
tombo detect_modifications aggregate_per_read_stats --minimum-test-reads 5 \
      --single-read-threshold 0.4 \
      --statistics-filename test_stats.de_novo.new_thresh.tombo.stats \
      --per-read-statistics-filename test_stats.de_novo.tombo.per_read_stats

printf "\n\n********* Testing ROC and Precision-Recall plotting **********\n"
tombo plot roc --genome-fasta e_coli.K12.NEB5alpha.fasta \
      --statistics-filenames test_stats.2samp.tombo.stats \
      test_stats.2samp_w_post.tombo.stats \
      test_stats.2samp_levels.tombo.stats \
      test_stats.alt_default_model.5mC.tombo.stats \
      test_stats.alt_default_model.6mA.tombo.stats \
      test_stats.de_novo.tombo.stats test_stats.de_novo.new_thresh.tombo.stats \
      --motif-descriptions \
      CCWGG:2:"dcm 5mC Samp Comp Model"::GATC:2:"dam 6mA Samp Comp Model" \
      CCWGG:2:"dcm 5mC Samp Comp w/ post"::GATC:2:"dam 6mA Samp Comp w/ post" \
      CCWGG:2:"dcm 5mC Samp Comp Levels"::GATC:2:"dam 6mA Samp Comp Levels" \
      CCWGG:2:"dcm 5mC Alt Test" GATC:2:"dam 6mA Alt Test" \
      CCWGG:2:"dcm 5mC De Novo"::GATC:2:"dam 6mA De Novo" \
      CCWGG:2:"dcm 5mC De Novo New Thresh"::GATC:2:"dam 6mA De Novo New Thresh"

tombo plot per_read_roc --genome-fasta e_coli.K12.NEB5alpha.fasta \
      --per-read-statistics-filenames test_stats.2samp.tombo.per_read_stats \
      test_stats.2samp_w_post.tombo.per_read_stats \
      test_stats.alt_default_model.5mC.tombo.per_read_stats \
      test_stats.alt_default_model.6mA.tombo.per_read_stats \
      test_stats.de_novo.tombo.per_read_stats --motif-descriptions \
      CCWGG:2:"dcm 5mC Samp Comp Model"::GATC:2:"dam 6mA Samp Comp Model" \
      CCWGG:2:"dcm 5mC Samp Comp w/ post"::GATC:2:"dam 6mA Samp Comp w/ post" \
      CCWGG:2:"dcm 5mC Alt Test" GATC:2:"dam 6mA Alt Test" \
      CCWGG:2:"dcm 5mC De Novo"::GATC:2:"dam 6mA De Novo"

printf "\n\n********* Testing Sample Compare ROC and Precision-Recall plotting **********\n"
tombo detect_modifications alternative_model --fast5-basedirs $natDir \
      --alternate-bases dam dcm \
      --statistics-file-basename test_stats.alt_native.motif \
      --per-read-statistics-basename test_stats.alt_native.motif
tombo detect_modifications alternative_model --fast5-basedirs $ampDir \
      --alternate-bases dam dcm \
      --statistics-file-basename test_stats.alt_amp_samp.motif \
      --per-read-statistics-basename test_stats.alt_amp_samp.motif
tombo detect_modifications de_novo --fast5-basedirs $ampDir \
      --minimum-test-reads 5 \
      --statistics-file-basename test_stats.de_novo.amp \
      --per-read-statistics-basename test_stats.de_novo.amp
tombo detect_modifications alternative_model --fast5-basedirs $ampDir \
      --alternate-bases 5mC 6mA \
      --statistics-file-basename test_stats.alt_default_model.amp \
      --per-read-statistics-basename test_stats.alt_default_model.amp
tombo plot sample_compare_roc --genome-fasta e_coli.K12.NEB5alpha.fasta \
      --statistics-filenames \
      test_stats.alt_native.motif.dcm.tombo.stats \
      test_stats.alt_native.motif.dam.tombo.stats \
      test_stats.de_novo.tombo.stats \
      test_stats.alt_default_model.5mC.tombo.stats \
      test_stats.alt_default_model.6mA.tombo.stats \
      --control-statistics-filenames \
      test_stats.alt_amp_samp.motif.dcm.tombo.stats \
      test_stats.alt_amp_samp.motif.dam.tombo.stats \
      test_stats.de_novo.amp.tombo.stats \
      test_stats.alt_default_model.amp.5mC.tombo.stats \
      test_stats.alt_default_model.amp.6mA.tombo.stats \
      --motif-descriptions CCWGG:2:"dcm 5mC Alt Test" \
      GATC:2:"dam 6mA Alt Test" \
      CCWGG:2:"dcm 5mC De novo"::GATC:2:"dam 6mA De novo" \
      CCWGG:2:"5mC all-context Alt Test" GATC:2:"6mA all-context Alt Test" \
      --pdf-filename test_stats.samp_comp_roc.pdf
tombo plot sample_compare_per_read_roc \
      --genome-fasta e_coli.K12.NEB5alpha.fasta \
      --per-read-statistics-filenames \
      test_stats.alt_native.motif.dcm.tombo.per_read_stats \
      test_stats.alt_native.motif.dam.tombo.per_read_stats \
      test_stats.de_novo.tombo.per_read_stats \
      test_stats.alt_default_model.5mC.tombo.per_read_stats \
      test_stats.alt_default_model.6mA.tombo.per_read_stats \
      --per-read-control-statistics-filenames \
      test_stats.alt_amp_samp.motif.dcm.tombo.per_read_stats \
      test_stats.alt_amp_samp.motif.dam.tombo.per_read_stats \
      test_stats.de_novo.amp.tombo.per_read_stats \
      test_stats.alt_default_model.amp.5mC.tombo.per_read_stats \
      test_stats.alt_default_model.amp.6mA.tombo.per_read_stats \
      --motif-descriptions CCWGG:2:"dcm 5mC Alt Test" \
      GATC:2:"dam 6mA Alt Test" \
      CCWGG:2:"dcm 5mC De novo"::GATC:2:"dam 6mA De novo" \
      CCWGG:2:"5mC all-context Alt Test" GATC:2:"6mA all-context Alt Test" \
      --pdf-filename test_stats.samp_comp_per_read_roc.pdf

printf "\n\n********* Testing Known Site ROC and Precision-Recall plotting **********\n"
tombo plot roc \
      --statistics-filenames test_stats.alt_native.motif.dcm.tombo.stats \
      --modified-locations "dcm 5mC":$modLocsFn \
      --unmodified-locations $unmodLocsFn
tombo plot per_read_roc \
      --per-read-statistics-filenames \
      test_stats.alt_native.motif.dcm.tombo.per_read_stats \
      --modified-locations "dcm 5mC":$modLocsFn \
      --unmodified-locations $unmodLocsFn

printf "\n\n********* Testing mutliple sample statistical testing genome-anchored plotting functions **********\n"
tombo plot max_difference --fast5-basedirs $natDir \
      --control-fast5-basedirs $ampDir \
      --num-bases 21 --overplot-threshold 1000 \
      --pdf-filename testing.max_diff.pdf
tombo plot most_significant --fast5-basedirs $natDir \
      --control-fast5-basedirs $ampDir \
      --num-bases 21 --overplot-threshold 1000 \
      --statistics-filename test_stats.2samp.tombo.stats \
      --pdf-filename testing.most_signif.2samp.pdf
tombo plot most_significant --fast5-basedirs $natDir \
      --control-fast5-basedirs $ampDir \
      --num-bases 21 --overplot-threshold 1000 \
      --statistics-filename test_stats.2samp_levels.tombo.stats \
      --pdf-filename testing.most_signif.2samp_levels.pdf
tombo plot most_significant --fast5-basedirs $natDir \
      --control-fast5-basedirs $ampDir \
      --num-bases 21 --overplot-threshold 1000 \
      --statistics-filename test_stats.de_novo.tombo.stats \
      --pdf-filename testing.most_signif.model.pdf
tombo plot most_significant --fast5-basedirs $natDir \
      --control-fast5-basedirs $ampDir \
      --num-bases 21 --overplot-threshold 1000 \
      --plot-standard-model \
      --statistics-filename test_stats.alt_model.5mC.tombo.stats \
      --pdf-filename testing.most_signif.alt_model_5mC.pdf
tombo plot motif_with_stats --fast5-basedirs $natDir \
      --motif CAW --genome-fasta $genomeFn --overplot-threshold 1000  \
      --plot-standard-model --statistics-filename test_stats.de_novo.tombo.stats \
      --pdf-filename testing.motif_w_stats.pdf
tombo plot motif_with_stats --fast5-basedirs $natDir \
      --tombo-model-filename $nrModFn --motif CCWGG \
      --genome-fasta $genomeFn --overplot-threshold 1000 \
      --statistics-filename test_stats.de_novo.tombo.stats \
      --pdf-filename testing.motif_w_stats.model.pdf
tombo plot motif_with_stats --fast5-basedirs $natDir \
      --control-fast5-basedirs $ampDir --motif CCWGG \
      --genome-fasta $genomeFn --overplot-threshold 1000 \
      --statistics-filename test_stats.2samp.tombo.stats \
      --pdf-filename testing.motif_w_stats.2samp.pdf
tombo plot motif_with_stats --fast5-basedirs $natDir \
      --control-fast5-basedirs $ampDir --motif CCWGG \
      --genome-fasta $genomeFn --overplot-threshold 1000 \
      --statistics-filename test_stats.2samp_levels.tombo.stats \
      --pdf-filename testing.motif_w_stats.2samp_levels.pdf
tombo plot motif_with_stats --fast5-basedirs $natDir \
      --plot-alternate-model 5mC --motif NNCCWGG --genome-fasta $genomeFn \
      --statistics-filename test_stats.alt_model.5mC.tombo.stats \
      --pdf-filename testing.motif_w_stats.alt_model_5mC.pdf
tombo plot motif_with_stats --fast5-basedirs $natDir \
      --plot-alternate-model 6mA --motif NGATC --genome-fasta $genomeFn \
      --statistics-filename test_stats.alt_default_model.6mA.tombo.stats \
      --pdf-filename testing.motif_w_stats.alt_model_6mA.alt_dist.pdf

printf "\n\n********* Testing overplotting options **********\n"
tombo plot max_coverage --fast5-basedirs $natDir \
        --num-bases 21 --overplot-threshold 1 --overplot-type Downsample \
        --pdf-filename testing.max_coverage.Downsample.pdf
tombo plot max_coverage --fast5-basedirs $natDir \
        --num-bases 21 --overplot-threshold 1 --overplot-type Boxplot \
        --pdf-filename testing.max_coverage.Boxplot.pdf
tombo plot max_coverage --fast5-basedirs $natDir \
        --num-bases 21 --overplot-threshold 1 --overplot-type Quantile \
        --pdf-filename testing.max_coverage.Quantile.pdf
tombo plot max_coverage --fast5-basedirs $natDir \
        --num-bases 21 --overplot-threshold 1 --overplot-type Density \
        --pdf-filename testing.max_coverage.Density.pdf
tombo plot max_coverage --fast5-basedirs $natDir \
        --control-fast5-basedirs $ampDir \
        --num-bases 21 --overplot-threshold 1 --overplot-type Downsample \
        --pdf-filename testing.max_coverage.2samp.Downsample.pdf
tombo plot max_coverage --fast5-basedirs $natDir \
        --control-fast5-basedirs $ampDir \
        --num-bases 21 --overplot-threshold 1 --overplot-type Boxplot \
        --pdf-filename testing.max_coverage.2samp.Boxplot.pdf
tombo plot max_coverage --fast5-basedirs $natDir \
        --control-fast5-basedirs $ampDir \
        --num-bases 21 --overplot-threshold 1 --overplot-type Quantile \
        --pdf-filename testing.max_coverage.2samp.Quantile.pdf
tombo plot max_coverage --fast5-basedirs $natDir \
        --control-fast5-basedirs $ampDir \
        --num-bases 21 --overplot-threshold 1 --overplot-type Density \
        --pdf-filename testing.max_coverage.2samp.Density.pdf

printf "\n\n********* Testing model-based plotting **********\n"
tombo plot max_coverage --fast5-basedirs $natDir \
        --tombo-model-filename $nrModFn \
        --pdf-filename testing.max_cov.1_samp.model.pdf
tombo plot most_significant --fast5-basedirs $natDir \
        --tombo-model-filename $nrModFn \
        --statistics-filename test_stats.de_novo.tombo.stats \
        --pdf-filename testing.model_plotting.pdf
tombo plot most_significant --fast5-basedirs $natDir \
        --tombo-model-filename $nrModFn \
        --statistics-filename test_stats.de_novo.tombo.stats \
        --overplot-threshold 1 --overplot-type Downsample \
        --pdf-filename testing.model_plotting.downsample.pdf
tombo plot most_significant --fast5-basedirs $natDir \
        --tombo-model-filename $nrModFn \
        --statistics-filename test_stats.de_novo.tombo.stats \
        --overplot-threshold 1 --overplot-type Boxplot \
        --pdf-filename testing.model_plotting.boxplot.pdf
tombo plot most_significant --fast5-basedirs $natDir \
        --tombo-model-filename $nrModFn \
        --statistics-filename test_stats.de_novo.tombo.stats \
        --overplot-threshold 1 --overplot-type Quantile \
        --pdf-filename testing.model_plotting.quant.pdf
tombo plot most_significant --fast5-basedirs $natDir \
        --tombo-model-filename $nrModFn \
        --statistics-filename test_stats.de_novo.tombo.stats \
        --overplot-threshold 1 --overplot-type Density \
        --pdf-filename testing.model_plotting.density.pdf
tombo plot genome_locations --fast5-basedirs $natDir \
        --tombo-model-filename $nrModFn \
        --alternate-model-filename $altModFn \
        --genome-locations $genomeLocs \
        --num-bases 21 --overplot-threshold 1000 \
        --pdf-filename testing.genome_loc.two_model_comp.pdf

printf "\n\n********* Testing event-resquiggled plotting **********\n"
tombo plot max_coverage --fast5-basedirs $natDir \
        --tombo-model-filename $nrModFn \
        --pdf-filename testing.max_cov.1_samp.model.model_resq.pdf \
        --corrected-group RawEventCorrected
tombo plot most_significant --fast5-basedirs $natDir \
        --tombo-model-filename $nrModFn \
        --corrected-group RawEventCorrected \
        --statistics-filename test_stats.de_novo.tombo.stats \
        --pdf-filename testing.model_plotting.resq_most_signif.pdf
tombo plot max_coverage --fast5-basedirs $natDir \
        --tombo-model-filename $nrModFn \
        --pdf-filename testing.max_cov.1_samp.model.model_resq.pdf \
        --corrected-group RawEventCorrected

printf "\n\n********* Testing per-read testing plot **********\n"
tombo plot per_read --genome-locations $genomeLocs --num-bases 101 \
      --per-read-statistics-filename test_stats.2samp.tombo.per_read_stats \
      --genome-fasta $genomeFn --pdf-filename testing.per_read.samp_comp.pdf
tombo plot per_read --genome-locations $genomeLocs --num-bases 101 \
      --per-read-statistics-filename test_stats.de_novo.tombo.per_read_stats \
      --genome-fasta $genomeFn --pdf-filename testing.de_novo.per_read.pdf
tombo plot per_read --fast5-basedirs $natDir \
      --genome-locations $genomeLocs --num-bases 101 \
      --per-read-statistics-filename test_stats.alt_model.5mC.tombo.per_read_stats \
      --pdf-filename testing.per_read.w_alt.pdf
tombo plot per_read --genome-locations $genomeLocs --num-bases 101 \
      --per-read-statistics-filename test_stats.alt_model.5mC.tombo.per_read_stats \
      --pdf-filename testing.per_read.wo_seq.pdf
# plot locs that should cluster
tombo detect_modifications alternative_model --fast5-basedirs $ampDir $natDir \
      --alternate-bases dam dcm \
      --statistics-file-basename test_stats.alt_both_samp.motif \
      --per-read-statistics-basename test_stats.alt_both_samp.motif
tombo plot per_read --genome-locations $genomeLocs --num-bases 10001 \
      --per-read-statistics-filename \
      test_stats.alt_both_samp.motif.dcm.tombo.per_read_stats \
      --genome-fasta $genomeFn \
      --pdf-filename testing.per_read.w_alt_motif.pdf

printf "\n\n********* Testing text output commands **********\n"
tombo text_output signif_sequence_context --fast5-basedirs $natDir $ampDir \
        --statistics-filename test_stats.de_novo.tombo.stats \
        --sequences-filename testing_signif_regions.from_fast5s.fasta
tombo text_output signif_sequence_context \
        --statistics-filename test_stats.de_novo.tombo.stats \
        --sequences-filename testing_signif_regions.from_fasta.fasta \
        --genome-fasta $genomeFn
tombo text_output browser_files --fast5-basedirs $natDir \
        --control-fast5-basedirs $ampDir \
        --file-types coverage signal signal_sd dwell difference
tombo text_output browser_files --fast5-basedirs $natDir \
        --control-fast5-basedirs $ampDir \
        --file-types coverage fraction signal signal_sd dwell difference \
        --statistics-filename test_stats.2samp.tombo.stats
tombo text_output browser_files --file-types statistic \
        --statistics-filename test_stats.2samp_levels.tombo.stats
tombo text_output browser_files --file-types fraction dampened_fraction \
        valid_coverage --statistics-filename \
        test_stats.de_novo.two_way_thresh.tombo.stats
tombo text_output browser_files --file-types fraction dampened_fraction \
        valid_coverage --statistics-filename \
        test_stats.alt_default_model.5mC.tombo.stats \
        --browser-file-basename test_stats.alt_5mC

printf "\n\n********* Testing other plotting commands **********\n"
tombo plot cluster_most_significant --fast5-basedirs $natDir \
        --control-fast5-basedirs $ampDir \
        --genome-fasta $genomeFn --num-regions 100 \
        --statistics-filename test_stats.2samp.tombo.stats
tombo plot cluster_most_significant --fast5-basedirs $natDir \
        --control-fast5-basedirs $ampDir \
        --genome-fasta $genomeFn --num-regions 100 \
        --r-data-filename testing.cluster_data.RData \
        --statistics-filename test_stats.2samp.tombo.stats
tombo plot cluster_most_significant --fast5-basedirs $natDir \
        --control-fast5-basedirs $ampDir \
        --genome-fasta $genomeFn --num-regions 100 \
        --statistics-filename test_stats.2samp_levels.tombo.stats \
        --pdf-filename testing.cluster_most_signif.2samp_levels.pdf
tombo plot kmer --fast5-basedirs $natDir \
        --num-kmer-threshold 0 \
        --pdf-filename testing.kmer_dist.median.all_events.pdf
tombo plot kmer --fast5-basedirs $natDir --read-mean \
        --num-kmer-threshold 1 \
        --pdf-filename testing.kmer_dist.median.pdf
tombo plot kmer --fast5-basedirs $natDir --read-mean \
        --corrected-group RawGenomeCorrected_pA_raw_000 \
        --num-kmer-threshold 1 \
        --pdf-filename testing.kmer_dist.pA_raw.pdf
tombo plot kmer --fast5-basedirs $natDir --read-mean \
        --corrected-group RawGenomeCorrected_pA_000 \
        --num-kmer-threshold 1 \
        --pdf-filename testing.kmer_dist.pA.pdf
